#
#
# $Id: indium.spec.in,v 1.21 2018-12-23 15:51:55+05:30 Cprogrammer Exp mbhangui $
%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1
%global debug_package %{nil}

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%global _verbose           1
%else
%define _project           local
%define build_on_obs       0
%global reconfigure_mode   0
%global _verbose           0
%global _hardened_build    1
%endif

%define _prefix            /usr
%define shareddir          /usr/share/indimail
%define mandir             /usr/share/man
%define libexecdir         /usr/libexec/indimail
%define sysconfdir         /etc/indimail
%define tai_version        1.2
%define fbsql_version      1.2
%define bwidget_version    1.8.0
%define tcl_version        8.6

%if %build_on_obs != 0
# change mysqlPrefix to /usr for openSUSE buildservice
%define mysqlPrefix        /usr
%else
%define mysqlPrefix        /usr
%endif
%define nobwidget          1

Summary: TCL/TK based Administration GUI for IndiMail
Name: indium
Version: 1.2
Release: 1.1%{?dist}

%if %build_on_obs == 1
License: GPL-3.0+
%else
License: GPLv3
%endif
Group: System Environment/Base
Source1:  http://downloads.sourceforge.net/indimail/%{name}-%{version}.tar.gz
Source2: %{name}-rpmlintrc

URL: https://github.com/mbhangui/indimail-virtualdomains
AutoReqProv: No
BuildRequires: tcl-devel rpm gcc gcc-c++ make binutils coreutils grep
BuildRequires: tk-devel glibc glibc-devel procps tcl tk cpio
BuildRequires: sed gettext-devel
BuildRequires: findutils openssl-devel openssl
BuildRequires: gzip autoconf indimail-devel libindimail mysql-devel
%if %{undefined rhel_version}
BuildRequires: sharutils
%else
%if 0%{?rhel_version} != 600 && 0%{?rhel_version} != 700
BuildRequires: sharutils
%endif
%endif
%if %{undefined centos_version} && %{undefined rhel_version} && %{undefined sles_version}
BuildRequires: chrpath
%endif
%if 0%{?suse_version}
BuildRequires: -post-build-checks  
#!BuildIgnore: post-build-checks  
%endif

Requires: coreutils grep /bin/sh glibc /usr/sbin/useradd /usr/sbin/groupadd
Requires: bwidget tcl tk procps /usr/bin/awk indimail > 1.6
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Excludeos: windows 

%description
Indium provides a GUI for administering IndiMail and configuring
associated components below

qmail,
daemontools,
ucspi-tcp,
Courier IMAP/POP3,
Bogofilter - A Bayesian Spam Filter,
Clam AntiVirus - GPL anti-virus toolkit for UNIX,
Fetchmail,

Indium also provides Management of Virtual domains.

%prep
echo "---------------- INFORMATION ------------------------"
echo target        %_target
echo target_alias  %_target_alias
echo target_cpu    %_target_cpu
echo target_os     %_target_os
echo target_vendor %_target_vendor
echo Building %{name}-%{version}-%{release} Build %{_build} OS %{_os} Dist %dist disttag %disttag libs %{_lib} %{_libdir}
echo "------------------------------------------------------"

for i in %{name}-%{version}
do
(
if [ -d $i ] ; then
  /bin/rm -rf $i
fi
if [ -f ../SOURCES/$i.tar.gz ] ; then
  gunzip -c ../SOURCES/$i.tar.gz |tar xf -
elif [ -f ../SOURCES/$i.tar.bz2 ] ; then
  bzip2 -d -c ../SOURCES/$i.tar.bz2 |tar xf -
else
  echo "No Source Archive for $i"
  exit 1
fi
if [ -d $i ] ; then
  if [ -f %{name}-%{version}/patches/$i.patch ] ; then
    # Copy for the SRPM
    /bin/cp %{name}-%{version}/patches/$i.patch ../SOURCES
  fi
fi
)
done

%build
ID=$(id -u)

#### Stupid Mandriva ######################
%if 0%{?mandriva_version} > 2009
%ifarch x86_64
%define _libdir %{_prefix}/lib64
%define _lib lib64
%else
%define _libdir %{_prefix}/lib
%define _lib lib
%endif
%endif

cd %{name}-%{version}
%configure --prefix=%{_prefix} --libdir=%{_libdir} \
  --libexecdir=%{libexecdir} --sysconfdir=%{sysconfdir} \
  --enable-shareddir=%{shareddir} \
  --mandir=%{mandir} --enable-mysqlprefix=/usr

%install
[ "$RPM_BUILD_ROOT" != "/" ] && /bin/rm -fr $RPM_BUILD_ROOT
ID=$(id -u)
for i in %{name}-%{version}
do
if [ -d $i ] ; then
  cd $i
  if [ %{_verbose} -eq 0 ] ; then
    %{__make} -s DESTDIR=%{buildroot}
    %{__make} -s DESTDIR=%{buildroot} install-strip
  else
    %{__make} DESTDIR=%{buildroot}
    %{__make} DESTDIR=%{buildroot} install-strip
  fi
  cd ..
fi
done
for i in fbsql tai64
do
  /bin/rm -f %{buildroot}%{_libdir}/lib"$i".la
  /bin/rm -f %{buildroot}%{_libdir}/lib"$i".a
done

%if %nobwidget == 0
. /usr/lib/tclConfig.sh
cd %{name}-%{version}
if [ $TCL_VERSION -ne %{tcl_version} ] ; then
  echo "tcl version mismatch $TCL_VERSION != %{tcl_version}"
  exit 1
fi
TCL_PATH=`echo $TCL_PACKAGE_PATH|awk '{print $1}'`
find ./BWidget-%{bwidget_version} -depth -print | cpio -pdmv %{buildroot}$TCL_PATH
%endif

# copy files here
if [ -x /usr/bin/chrpath ] ; then
  /usr/bin/chrpath -d %{buildroot}%{libexecdir}/pwhelper
fi
%{__rm} -f %{buildroot}%{_libdir}/*.so

%files
%defattr(-, root, root,-)
%dir %attr(755,root,root)              %{shareddir}/indium
%dir %attr(755,root,root)              %{shareddir}/indium/scripts
%dir %attr(755,root,root)              %{shareddir}/indium/images
%dir %attr(755,root,root)              %{shareddir}/indium/lib
#
# Image files
#
%attr(644,root,root)                %{shareddir}/indium/images/adddomain.gif
%attr(644,root,root)                %{shareddir}/indium/images/addgroup.gif
%attr(644,root,root)                %{shareddir}/indium/images/adduser.gif
%attr(644,root,root)                %{shareddir}/indium/images/arrow_left.gif
%attr(644,root,root)                %{shareddir}/indium/images/arrow_right.gif
%attr(644,root,root)                %{shareddir}/indium/images/atrn.gif
%attr(644,root,root)                %{shareddir}/indium/images/bulletin.gif
%attr(644,root,root)                %{shareddir}/indium/images/buttonexit.gif
%attr(644,root,root)                %{shareddir}/indium/images/buttonlogin.gif
%attr(644,root,root)                %{shareddir}/indium/images/cron.gif
%attr(644,root,root)                %{shareddir}/indium/images/dbcontrol.gif
%attr(644,root,root)                %{shareddir}/indium/images/deldomain.gif
%attr(644,root,root)                %{shareddir}/indium/images/delolduser.gif
%attr(644,root,root)                %{shareddir}/indium/images/deluser.gif
%attr(644,root,root)                %{shareddir}/indium/images/edit.gif
%attr(644,root,root)                %{shareddir}/indium/images/exit.gif
%attr(644,root,root)                %{shareddir}/indium/images/filemanager.gif
%attr(644,root,root)                %{shareddir}/indium/images/folder.gif
%attr(644,root,root)                %{shareddir}/indium/images/folder.xbm
%attr(644,root,root)                %{shareddir}/indium/images/forum.gif
%attr(644,root,root)                %{shareddir}/indium/images/go.gif
%attr(644,root,root)                %{shareddir}/indium/images/gq.gif
%attr(644,root,root)                %{shareddir}/indium/images/green.gif
%attr(644,root,root)                %{shareddir}/indium/images/greenoff.gif
%attr(644,root,root)                %{shareddir}/indium/images/greenon.gif
%attr(644,root,root)                %{shareddir}/indium/images/help.gif
%attr(644,root,root)                %{shareddir}/indium/images/indimaillogo_small.gif
%attr(644,root,root)                %{shareddir}/indium/images/linux.xbm
%attr(644,root,root)                %{shareddir}/indium/images/linux_mask.xbm
%attr(644,root,root)                %{shareddir}/indium/images/loginleft.gif
%attr(644,root,root)                %{shareddir}/indium/images/logintop.gif
%attr(644,root,root)                %{shareddir}/indium/images/mbar1.gif
%attr(644,root,root)                %{shareddir}/indium/images/moduser.gif
%attr(644,root,root)                %{shareddir}/indium/images/neat.gif
%attr(644,root,root)                %{shareddir}/indium/images/passwd.gif
%attr(644,root,root)                %{shareddir}/indium/images/postel.gif
%attr(644,root,root)                %{shareddir}/indium/images/preferences.gif
%attr(644,root,root)                %{shareddir}/indium/images/pwrdLogo150.gif
%attr(644,root,root)                %{shareddir}/indium/images/queuestatus.gif
%attr(644,root,root)                %{shareddir}/indium/images/quit.gif
%attr(644,root,root)                %{shareddir}/indium/images/red.gif
%attr(644,root,root)                %{shareddir}/indium/images/reload.gif
%attr(644,root,root)                %{shareddir}/indium/images/secpanel.gif
%attr(644,root,root)                %{shareddir}/indium/images/serviceTool.gif
%attr(644,root,root)                %{shareddir}/indium/images/flash.gif
%attr(644,root,root)                %{shareddir}/indium/images/showctl.gif
%attr(644,root,root)                %{shareddir}/indium/images/slemslite.gif
%attr(644,root,root)                %{shareddir}/indium/images/smtp.gif
%attr(644,root,root)                %{shareddir}/indium/images/stop.gif
%attr(644,root,root)                %{shareddir}/indium/images/textedit.gif
%attr(644,root,root)                %{shareddir}/indium/images/tkrat.xbm
%attr(644,root,root)                %{shareddir}/indium/images/tkratmask.xbm
%attr(644,root,root)                %{shareddir}/indium/images/top.gif
%attr(644,root,root)                %{shareddir}/indium/images/version.gif
%attr(644,root,root)                %{shareddir}/indium/images/warning.gif
%attr(644,root,root)                %{shareddir}/indium/images/back.gif
%attr(644,root,root)                %{shareddir}/indium/images/configs_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/connects_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/indadmin_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/keys_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/profiles_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/sscreen_gr.gif
%attr(644,root,root)                %{shareddir}/indium/images/bwidget.xbm
%attr(644,root,root)                %{shareddir}/indium/images/file.gif
%attr(644,root,root)                %{shareddir}/indium/images/filemiss.gif
%attr(644,root,root)                %{shareddir}/indium/images/hourglass.gif
%attr(644,root,root)                %{shareddir}/indium/images/x1.xbm


%if %nobwidget == 0
#
# BWidget
#

%dir %attr(755,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}
%dir %attr(755,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman
%dir %attr(755,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images
%dir %attr(755,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang

%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/README.txt
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ScrollView.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/PanelFrame.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/SelectColor.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/MainFrame.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/DropSite.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Separator.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/NoteBook.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ScrollableFrame.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/DragSite.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ListBox.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/PagesManager.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Dialog.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Widget.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Button.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/PanedWindow.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/navtree.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/LabelFrame.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/DynamicHelp.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/index.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/PasswdDlg.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/options.htm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/MessageDlg.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ProgressBar.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/TitleFrame.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Tree.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/StatusBar.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/SelectFont.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/BWidget.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ButtonBox.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/LabelEntry.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Entry.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ScrolledWindow.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/contents.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ProgressDlg.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/SpinBox.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ArrowButton.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/ComboBox.html
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/BWman/Label.html

%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/scrollw.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/notebook.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/separator.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/color.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/bitmap.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/labelentry.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/combobox.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/buttonbox.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/progressdlg.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/button.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/labelframe.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/entry.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/scrollframe.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/pkgIndex.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/mainframe.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/wizard.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/font.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/arrow.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/ChangeLog
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/titleframe.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/progressbar.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/dialog.tcl

%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/CHANGES.txt
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/italic.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/save.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/minus.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/warning.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/file.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/paste.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/bold.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/undo.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/underline.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/opcopy.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/print.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/palette.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/overstrike.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/copy.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/info.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/question.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/openfold.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/plus.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/passwd.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/cut.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/open.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/hourglass.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/oplink.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/redo.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/new.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/dragfile.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/dragicon.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/opmove.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/folder.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/target.xbm
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/images/error.gif
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/scrollview.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/init.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang/en.rc
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang/fr.rc
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang/de.rc
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang/es.rc
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/lang/da.rc
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/spinbox.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/listbox.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/tree.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/LICENSE.txt
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/utils.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/dropsite.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/dragsite.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/panedw.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/panelframe.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/xpm2image.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/messagedlg.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/widget.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/dynhelp.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/label.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/statusbar.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/passwddlg.tcl
%attr(644,root,root) /usr/%{_lib}/tcl%{tcl_version}/BWidget-%{bwidget_version}/pagesmgr.tcl
%endif
#
# These files will get removed during installation
#
%attr(755,root,root)                %{_prefix}/bin/FMbrowse
%attr(755,root,root)                %{_prefix}/bin/indium
%attr(755,root,root)                %{_prefix}/bin/litesrc
%attr(755,root,root)                %{_prefix}/bin/secpanel
%attr(755,root,root)                %{_prefix}/bin/supernotepad
%attr(755,root,root)                %{_prefix}/bin/tkdiff
%attr(755,root,root)                %{libexecdir}/pwhelper
%attr(755,root,root)                %{shareddir}/indium/scripts/dppw.tcl
%attr(755,root,root)                %{shareddir}/indium/scripts/spdistkey
%attr(755,root,root)                %{shareddir}/indium/scripts/secpanel.wait
%attr(755,root,root)                %{shareddir}/indium/scripts/secpanel_remoteconf.sh
%attr(644,root,root)                %{shareddir}/indium/scripts/convert_profile.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/convert_history.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/balloon.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/base64.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/combobox.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/common.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/export_profiles.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/fileman.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/global.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/gui.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/help.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/hugecombo.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/hugelist.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/IndiMailHelp.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/mclistbox.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/notebook.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/progressbar.tcl
%attr(644,root,root)                %{shareddir}/indium/scripts/ranges.tcl

# Shared libraries (omit for architectures that don't support them)
%{_libdir}/libtai64-%{tai_version}.so.0
%{_libdir}/libtai64-%{tai_version}.so.0.0.0
%{_libdir}/libfbsql-%{fbsql_version}.so.0
%{_libdir}/libfbsql-%{fbsql_version}.so.0.0.0

#
# If the configuration file should not be replaced when the RPM is
# upgraded, mark it as follows:
#
# For files that should be included in the list of files so that they
# are uninstalled when the package is removed but may not exist until
# they are created during post-install should be marked as follows:
#
%doc %attr(644, root, root)                       %{shareddir}/indium/lib/userhelp.txt
%attr(644,root,root) %config(noreplace,missingok) %{sysconfdir}/default.config
%attr(644,root,root) %config(noreplace,missingok) %{sysconfdir}/default.profile
%attr(644,root,root) %config(noreplace,missingok) %{sysconfdir}/filemanrc
%attr(644,root,root) %config(noreplace,missingok) %{sysconfdir}/termdefs.txt

%clean
%{__rm} -rf %{buildroot}

#          install   erase   upgrade  reinstall
# %% pre         1        -         2         2
# %% post        1        -         2         2
# %% preun       -        0         1         -
# %% postun      -        0         1         -
%pre 
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root"
  exit 1
fi

%post
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root"
  exit 1
fi
/sbin/ldconfig

%preun
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root"
  exit 1
fi

%postun
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root"
  exit 1
fi
if [ $argv1 -eq 1 ] ; then
  echo "recreating ld.so cache"
  /sbin/ldconfig
  exit 0
fi
echo "recreating ld.so cache"
/sbin/ldconfig

# fix changelog for openSUSE buildservice
%changelog
* Fri Jun 19 2020 22:36:48 +0530 indium@indimail.org 1.2-1.1%{?dist}
Release 1.2 Start 19/06/2020
    - 19/06/2020
1.  Add AC_PROG_CC_C99 to configure
2.  RPM/debian Build Fixes
3.  added create_rpm, create_debian scripts
